#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <iostream>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netinet/ip.h>

using namespace std;

struct ClientParameters
{
	sockaddr_in clientAddress_;
	int socketToClient_;
};

bool foundAChar(const char* buffer, char QUIT_CHAR)
{
	while (*buffer != 0 && *buffer != QUIT_CHAR) ++buffer;
	return (*buffer == QUIT_CHAR);
}

void processServerRequest(ClientParameters* parameters)
{
	// Create an input buffer to hold the data we recv
	const int MAX_CHARS_TO_READ = 1024;
	char inputBuffer[MAX_CHARS_TO_READ + 1];
	bool userHasQuit = false;
	const char QUIT_CHAR = '*';

	while (!userHasQuit)
	{
		int nBytesRead = recv(parameters->socketToClient_,
			inputBuffer, MAX_CHARS_TO_READ, 0);

		if (nBytesRead > 0)
		{
			// Null terminate the string
			inputBuffer[nBytesRead] = 0;

			// Write to the screen
			cerr << "From "
				<< inet_ntoa(parameters->clientAddress_.sin_addr)
				<< ": "
				<< inputBuffer << endl;

			// Echo the message back the client
			send(parameters->socketToClient_, inputBuffer, nBytesRead, 0);

			userHasQuit = foundAChar(inputBuffer, QUIT_CHAR);
			const char QUIT_CHAR = '*';

			while (!userHasQuit)
			{
				int nBytesRead = recv(parameters->socketToClient_,
					inputBuffer, MAX_CHARS_TO_READ, 0);

				if (nBytesRead > 0)
				{
					// Null terminate the string
					inputBuffer[nBytesRead] = 0;

					// Write to the screen
					cerr << "From "
						<< inet_ntoa(parameters->clientAddress_.sin_addr)
						<< ": "
						<< inputBuffer << endl;

					// Echo the message back the client
					send(parameters->socketToClient_, inputBuffer, nBytesRead, 0);

					userHasQuit = foundAChar(inputBuffer, QUIT_CHAR);

				}
				// Sleep(2000);
			}

			close(parameters->socketToClient_);
			delete parameters;
		}

		int main()
		{

			// Create a TCP/IP socket
			int lcSocket =
				socket(AF_INET, SOCK_STREAM, 0);

			struct sockaddr_in serverAddress;

			// Set all the bytes in serverAddress
			// to zero.
			memset(&serverAddress, 0,
				sizeof(serverAddress));

			serverAddress.sin_family = AF_INET;

			// Provide service on any IP address
			// available.
			serverAddress.sin_addr.s_addr =
				htonl(INADDR_ANY);

			// Assign a port number that is
			// is specific for our service
			unsigned short portNumber = 50001;
			serverAddress.sin_port = htons(portNumber);

			int bindStatus = bind(lcSocket,
				reinterpret_cast<sockaddr*>(&serverAddress),
				sizeof(serverAddress));

			if (bindStatus < 0)
			{
				cerr << "bind failed with status " <<
					bindStatus << endl;
			}
			else
			{
				cerr << "Bind was successful!!!" << endl;
				const int MAX_WAITING_FOR_CONNECTION = 5;
				listen(lcSocket, MAX_WAITING_FOR_CONNECTION);

				struct sockaddr_in clientAddress;
				int clientAddressLength = sizeof(clientAddress);

				int client;

				while (true)
				{
					// accept is "blocking call"
					// The program will not proceed until a
					// client connects.
					client = accept(lcSocket,
						reinterpret_cast<sockaddr*>(&clientAddress),
						reinterpret_cast<socklen_t*>(&clientAddressLength));

					cerr << "Got a connection!" << endl;
					cerr << "client's IP address is:" <<
						inet_ntoa(clientAddress.sin_addr) << endl;

					int childId = 0;
					childId = fork();

					// At this point there are two processes
					// The child has childId == 0
					// The parent has childId =
					//    to the pid of the child
					if (childId == 0)
					{

						cerr << "client port number is: " <<
							ntohs(clientAddress.sin_port) << endl;
                                struct ClientParameters* parameters =
                                        new ClientParameters;
                                parameters->socketToClient_ = client;
                                memcpy((void*)&parameters->clientAddress_,
                        (void*)&clientAddress, sizeof(sockaddr_in));

                                processServerRequest(parameters);
                                }

                                // Wait for the next connection
                        }
                }

        system("pause");
}
